// @ myth - common - picture.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef PICTURE_HEADER
#define PICTURE_HEADER

// @@ include

#include "common/common.h"

// @@ class PICTURE

class PICTURE
{
    char** buffer;
    coor Size;
    void free();
public:
    inline char& operator[](coor pos) CONST_MEMBER
    { return buffer[pos.y][pos.x]; }
    inline coor size()  CONST_MEMBER
    { return Size; }
    void resize(coor size, char fill = ' ');
    const PICTURE& operator=(const PICTURE& picture);
    PICTURE(const PICTURE& picture);
    PICTURE();
    PICTURE(coor size, char fill = ' ');
    ~PICTURE();
};

// @@ end

#endif PICTURE_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
